/*
 * Copyright (c)  2018 - 2021 Daniel Quah
 * Copyright (c)  2021 ASDF Dev Pte. Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package xyz.hisname.fireflyiii.ui.settings

import android.content.Context
import android.os.Bundle
import androidx.core.app.NotificationManagerCompat
import androidx.preference.CheckBoxPreference
import kotlinx.android.synthetic.main.activity_base.*
import xyz.hisname.fireflyiii.R
import xyz.hisname.fireflyiii.ui.notifications.NotificationUtils

class TransactionSettings: BaseSettings() {

    override fun onCreatePreferences(savedInstanceState: Bundle?, rootKey: String?) {
        addPreferencesFromResource(R.xml.user_transaction_settings)
        addPermNotif()
    }

    private fun addPermNotif(){
        val transactionPref = findPreference<CheckBoxPreference>("persistent_notification") as CheckBoxPreference
        val notification = NotificationUtils(requireContext())
        transactionPref.setOnPreferenceChangeListener { _, newValue ->
            if(newValue == true){
                notification.showTransactionPersistentNotification()
            } else {
                NotificationManagerCompat.from(requireContext()).cancel("transaction_notif",12345)
            }
            true
        }
    }

    override fun onAttach(context: Context) {
        super.onAttach(context)
        activity?.activity_toolbar?.title = "Transaction Settings"
    }

    override fun onResume() {
        super.onResume()
        activity?.activity_toolbar?.title = "Transaction Settings"
    }
}